Bug 123849 - openldap can't connect to OID- Oracle Internet Directory using ldaps
openldap can't connect to OID- Oracle Internet Directory using ldaps
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: openldap (Show other bugs)
3.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jan Safranek
Jay Turner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-05-20 18:52 EDT by Frank Berger
Modified: 2015-01-07 19:07 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-19 15:26:07 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
debug output of the ldapsearch command used to show the problem (108.86 KB, text/plain)
2004-05-20 18:54 EDT, Frank Berger
no flags Details
quick&dirty fix for the problem setting SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS (907 bytes, patch)
2004-05-20 18:58 EDT, Frank Berger
no flags Details | Diff

  None (edit)
Description Frank Berger 2004-05-20 18:52:32 EDT
Description of problem:
It is not possible to connect to the Oracle Internet Directory
(version 9.0.4) with OpenLDAP using LDAPs.

The problem is related to an security fix introduced in OpenSSL
version 0.9.6d. (see: Implement a countermeasure against a 
vulnerability recently found in CBC ciphersuites in SSL 3.0/TLS 1.0
by Bodo Moeller in the openssl changelog).

This fix seems not to be compliant with the SSL implementation
used by Oracle.

Solution would be to set the SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS
option within the SSL_CTX of the libldap code. (see the attached
patch).

This patch on the other side may cause security problems :-(.


Version-Release number of selected component (if applicable):
Fedora Core 1:
OpenLDAP 2.1.22-8
OpenSSL 0.9.7a-33.10

RHEL 3:
OpenLDAP 2.0.27-11
OpenSSL 0.9.7a-22.1

How reproducible:
always

Steps to Reproduce:
1. setup a custom configset for Oracle Internet Directory using 
   SSL Server Authentication
2. create $HOME/ldaprc with:
   ---
   TLS_CACERT /home/frank/oid-caroot.pem
   TLS_REQCERT allow
   TLS_CIPHERS SSLv3
   ssl on
   tls_checkpeer no
   ---
3. try to perform the following ldapsearch command:
---
ldapsearch -D "cn=orcladmin,cn=Users,dc=fm-berger,dc=de" -w password
-H ldaps://fm-berger.de:4055/ -d 7 -b "cn=Users,dc=fm-berger,dc=de" -x
"(objectclass=*)"
---
see the attached output of this command.
  
Actual results:
1. initial SSL handshake works
2. ldap-bind request is send
3. connection is terminated by OID lapsearch output:
---
TLS trace: SSL3 alert read:fatal:close notify
ldap_read: want=8, got=0
 
ldap_perror
ldap_bind: Can't contact LDAP server (-1)
---

Expected results:
successful ldaps connection with result.

Additional info:
This issue is also filed to Oracle Metalink under the TAR-ID:
3788414.996 (EL 5/20 MORE INFORMATION FOR OID/SSL / TLS SUPPORTED?)
Comment 1 Frank Berger 2004-05-20 18:54:31 EDT
Created attachment 100402 [details]
debug output of the ldapsearch command used to show the problem
Comment 2 Frank Berger 2004-05-20 18:58:11 EDT
Created attachment 100403 [details]
quick&dirty fix for the problem setting SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS

Warning! This patch may cause security problems when applied!
Comment 4 RHEL Product and Program Management 2007-10-19 15:26:07 EDT
This bug is filed against RHEL 3, which is in maintenance phase.
During the maintenance phase, only security errata and select mission
critical bug fixes will be released for enterprise products. Since
this bug does not meet that criteria, it is now being closed.
 
For more information of the RHEL errata support policy, please visit:
http://www.redhat.com/security/updates/errata/
 
If you feel this bug is indeed mission critical, please contact your
support representative. You may be asked to provide detailed
information on how this bug is affecting you.

Note You need to log in before you can comment on or make changes to this bug.